## debconf 0.2.80.17

=== Makefile ===
all: Version.pm
	$(MAKE) -C doc

VERSION=$(shell expr "`dpkg-parsechangelog 2>/dev/null |grep Version:`" : '.*Version: \(.*\)')
Version.pm:
	echo -e "package Debian::DebConf::Version;\n\$$version='$(VERSION)';" > Version.pm

test:
	samples/$(PACKAGE)

clean:
	find . -name \*~ | xargs rm -f
	rm -f *.db Version.pm
	$(MAKE) -C doc clean

install-common:
	install -d $(prefix)/usr/lib/perl5/Debian/DebConf/ \
		$(prefix)/var/lib/debconf \
		$(prefix)/usr/share/debconf/templates
	chmod 700 $(prefix)/var/lib/debconf
	install -m 0644 *.pm $(prefix)/usr/lib/perl5/Debian/DebConf/
	find Client Element FrontEnd -type d | grep -v CVS | \
		xargs -i_ install -d $(prefix)/usr/lib/perl5/Debian/DebConf/_
	find Client Element FrontEnd -type f | grep .pm\$$ | \
		xargs -i_ install -m 0644 _ $(prefix)/usr/lib/perl5/Debian/DebConf/_
	install -m 0644 Client/confmodule.sh Client/confmodule $(prefix)/usr/share/debconf/
	install Client/frontend $(prefix)/usr/share/debconf/
	 # Modify config module to use correct db location.
	sed 's:.*# CHANGE THIS AT INSTALL TIME:"/var/lib/debconf/":' \
		< Config.pm > $(prefix)/usr/lib/perl5/Debian/DebConf/Config.pm

install: install-common
	# Generate man pages from POD docs.
	install -d $(prefix)/usr/share/man/man3/
	pod2man Client/ConfModule.pm > $(prefix)/usr/share/man/man3/Debian::Debconf::Client::ConfModule.3pm
	# Install bins
	install -d $(prefix)/usr/sbin
	find Client -perm +1 -type f | grep -v frontend | \
		xargs -i_ install _ $(prefix)/usr/sbin

# This target installs a minimal debconf.
tiny-install: install-common
	# Delete the libs we don't need.
	find $(prefix)/usr/lib/perl5/Debian/DebConf/ | egrep 'Text|Web|Gtk' \
		| grep -v Dialog/ | xargs rm -rf
	# Strip out POD documentation and all other comments
	# from all .pm files.
	find $(prefix)/usr/lib/perl5/Debian/DebConf/ -name '*.pm' | \
		xargs perl -i.bak -ne ' \
			$$cutting=!$$cutting if /^=/; \
			next if $$cutting; \
			print $$_ unless /^(=|\s*#)/ \
		'
	find $(prefix)/usr/lib/perl5/Debian/DebConf/ -name '*.bak' | xargs rm -f
	install -d $(prefix)/usr/sbin $(prefix)/usr/share/man/man8
	install Client/dpkg-reconfigure Client/dpkg-preconfigure \
		$(prefix)/usr/sbin/
	cp Client/dpkg-reconfigure.8 Client/dpkg-preconfigure.8 \
		$(prefix)/usr/share/man/man8

=== doc/Makefile ===
FILES=$(patsubst %.xml,%.txt,$(wildcard *.xml)) \
      $(patsubst %.xml,%.html,$(wildcard *.xml))

all: $(FILES) spec
	./graph.pl `find .. -name \*.pm` > hierarchy.txt
	-$(MAKE) -C spec all

%.html: %.xml html.dsl
	jade -V nochunks -t sgml -d html.dsl \
		/usr/lib/sgml/declaration/xml.dcl $< | sed 's/&#13;//' > $@

%.txt: %.html
	w3m -dump $< > $@
#	lynx -dump $< > $@

clean: spec
	rm -f $(FILES) hierarchy.txt *.css *.html
	-$(MAKE) -C spec clean

# Spec is in a different cvs repository, make sure it's available.
# This is mostly for my own loacal use; I ship it in the source package.
spec:
	cvs -d :ext:joeyh@cvs.debian.org:/var/cvs/debconf co spec

=== doc/spec/Makefile ===
all: specification.txt specification.html

%.html: %.xml html.dsl
	jade -V nochunks -t sgml -d html.dsl \
		/usr/lib/sgml/declaration/xml.dcl $< | sed 's/&#13;//' > $@

%.txt: %.html
	w3m -dump $< > $@

clean:
	rm -f *.css *.html *.txt

=== debian/changelog ===
debconf (0.2.80.17) stable; urgency=low

  * Disabled locales. The issue is that select elements are quite broken
    if used in no-C locales. So broken that any package that uses them with
    debconf will probably get quite confused. This is fixed in woody, but
    the fix was quite a lot of code, so it seems safer just to disable
    them. I modified one line of code.

 -- Joey Hess <joeyh@debian.org>  Mon, 28 Aug 2000 21:37:00 -0700

debconf (0.2.80.16) frozen; urgency=low

  * I don't think this will actually get into frozen, but it fixes my most
    common problem report, and I had to build it anyway for something else,
    so may be worth a shot. Release maanger, feel free to reject.
  * Catch undefined value returned if a package that is not installed is
    preconfigured, and use '' instead. This clears up the undefined value
    warning people have been seeing for months, especially on fresh debian
    installs where a lot of stuff gets preconfigured and you see it about
    20 times. (see bugs #55498, #57792, #62263, #53657) This fix has been
    tested for 2 months in the woody debconf tree, and works.

 -- Joey Hess <joeyh@debian.org>  Fri, 21 Jul 2000 15:01:08 -0700

debconf (0.2.80.15) frozen; urgency=low

  * Fixed a typo that breaks the web frontend. Closes: #64474 
    (severity important)

 -- Joey Hess <joeyh@debian.org>  Sun, 21 May 2000 20:37:35 -0700

debconf (0.2.80.14) frozen; urgency=low

  * Made noninteractive select elements smarter. If the value is set, but
    is set to something not on the list, disregard it and pick the first
    element from the list. This is actually an important bugfix; it's been
    causing problems with apt-setup in base-config, making
    http.us.debian.org be incorrectly picked as the default when users try
    to set up apt to use a country that just has one mirror on file.
  * Closes #60160 (important)

 -- Joey Hess <joeyh@debian.org>  Mon, 13 Mar 2000 13:23:18 -0800

debconf (0.2.80.13) frozen; urgency=low

  * Use fully-qualified path for dpkg-preconfigure in apt.conf, 
    Closes: #58469

 -- Joey Hess <joeyh@debian.org>  Wed,  1 Mar 2000 11:35:07 -0800

debconf (0.2.80.12) frozen; urgency=low

  * When debconf or debconf-tiny is purged, the database is not deleted if
    debconf or debconf-tiny is still installed. Closes: #59029

 -- Joey Hess <joeyh@debian.org>  Mon, 28 Feb 2000 13:19:16 -0800

debconf (0.2.80.11) frozen; urgency=low

  * Catch SIGPIPEs from confmodules and handle them. Closes: #58847, #58818

 -- Joey Hess <joeyh@debian.org>  Thu, 24 Feb 2000 10:32:40 -0800

debconf (0.2.80.10) frozen; urgency=low

  * dpkg-reconfigure: don't run the postrm of the package. Doing so breaks
    things when for example, the package uses dpkg-divert and tries to remove
    diversions in the postrm. This cannot be an isolated problem either. This
    reverses the change made in version 0.2.52, which did not say why I
    added it in the first place.. Closes: #58527 (important bug)

 -- Joey Hess <joeyh@debian.org>  Sat, 19 Feb 2000 20:47:00 -0800

debconf (0.2.80.9) frozen; urgency=low

  * Rebuild to fix 0 length documentation files (I have no idea what caused
    them). Closes: #58493

 -- Joey Hess <joeyh@debian.org>  Sat, 19 Feb 2000 17:55:47 -0800

debconf (0.2.80.8) frozen; urgency=low

  * Fixed bad merge of changes that I thought was done in 0.2.80.6; fixes 2
    important bugs.
  * Fixed minor back problem in debconf's own config script, and some
    documentation fixes.

 -- Joey Hess <joeyh@debian.org>  Thu, 17 Feb 2000 11:52:21 -0800

debconf (0.2.80.7) frozen; urgency=low

  * Important fix: don't accidentially delete Dialog/Text.pm from
    debconf-tiny.

 -- Joey Hess <joeyh@debian.org>  Tue, 15 Feb 2000 13:11:58 -0800

debconf (0.2.80.6) frozen; urgency=low

  * dpkg-preconfigure: It turns out that the trick of reading from stdin
    until EOF, then reading more later only works if stdin is a tty. When it
    was running from apt, that wasn't so, and so it caused dialog to lock up,
    in a tight loop, unable to read keypresses from stdin. The fix is
    pretty simple; just open /dev/tty and connect STDIN to it after reading
    the filelist from apt. Closes: #56518, #57771 (important bugs).
  * Disabled dialog exclusion that was added in the last release.

 -- Joey Hess <joeyh@debian.org>  Mon, 14 Feb 2000 11:43:52 -0800

debconf (0.2.80.5) frozen; urgency=low

  * Fixed dpkg-preconfigure to not use Getopt::Long, so it will work even on
    the base system it is now a part of.
  * As a workaround for the dialog lock problem (which seems to be a dialog
    bug), never use dialog for the text mode menus. Works around: #56518
    (grave), #57771 (important)

 -- Joey Hess <joeyh@debian.org>  Sun, 13 Feb 2000 00:35:47 -0800

debconf (0.2.80.4) frozen; urgency=low

  * Add templates file, config script, postinst, and posrtm to debconf-tiny,
    so debconf/priority actually exists. This is necessary so base-config
    can change the priority if the boot-floppies were installed in verbose or
    quiet mode. This is a critical bugfix, as it fixes a bug that made newly
    installed systems unusable.
  * Added dpkg-preconfigure to debconf-tiny, since this:
    a) lets debconf-tiny use debconf's postinst unchanged
    b) is useful in general to have in debconf-tiny
  * Several k of bloat. Oh well..

 -- Joey Hess <joeyh@debian.org>  Wed,  9 Feb 2000 18:12:24 -0800

debconf (0.2.80.3) frozen; urgency=low

  * dpkg-reconfigure: detect perl confmodules properly, by making my regexp
    match case in-sensitively. This fixes a bug that made dpkg-reconfigure
    not work at all to reconfigure packages that used ConfModule.pm.
    Probably worth putting into frozen, especially as it is a 1 character
    (count 'em!) bugfix.

 -- Joey Hess <joeyh@debian.org>  Tue,  8 Feb 2000 10:35:10 -0800

debconf (0.2.80.2) frozen; urgency=low

  * Installed workaround from Joel Klecker to fix the annoying termcap


=== debian/control ===
Source: debconf
Section: admin
Priority: optional
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.2.1.0
Build-Depends-Indep: debhelper (>= 2.0.49), links, jade, sp, docbook-xml, docbook-stylesheets, sgml-data (>= 1.2)

Package: debconf
Architecture: all
Conflicts: debconf-tiny, apt (<< 0.3.12.1), menu (<= 2.1.3-1), gnome-utils (<< 1.0.13-2), libgtk-perl (<< 0.6123-1), dialog (<< 0.9a-17), whiptail (<< 0.50-1)
Provides: debconf-tiny
Replaces: debconf-tiny
Depends: perl-5.005, fileutils (>= 4.0-5)
Suggests: libterm-readline-gnu-perl, whiptail | dialog | gnome-utils
Description: Debian configuration management system
 Debconf is a configuration management system for debian packages. It is
 used by some packages to prompt you for questions before they are installed.

Package: debconf-tiny
Architecture: all
Conflicts: debconf, menu (<= 2.1.3-1), gnome-utils (<< 1.0.13-2), dialog (<< 0.9a-17), whiptail (<< 0.50-1)
Suggests: whiptail
Depends: perl-5.005-base (>= 5.005.03-4.1)
Provides: debconf
Description: Tiny subset of debconf for the base system
 Debconf is a configuration management system for debian packages. It is 
 used by some packages to prompt you for questions before they are installed.
 .
 This is a tiny subset of debconf, with only one frontend, few features. It is
 intended to be used to set up things in the base system that use debconf.
 Unless you are very short on disk space, you should install debconf instead.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules that uses debhelper. GNU copyright 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

fixlinks:
	ln -sf templates debian/debconf-tiny.templates
	ln -sf config debian/debconf-tiny.config 
	ln -sf postinst debian/debconf-tiny.postinst         
	ln -sf postrm debian/debconf-tiny.postrm

build: fixlinks
	$(MAKE)
	dh_testdir

clean:
	dh_testdir
	dh_testroot
	$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) prefix=debian/tmp install
	$(MAKE) prefix=debian/debconf-tiny tiny-install

# Build architecture-independent files here.
binary-indep: install
	# Make sure debhelper is going to install the config and templates.
	dh_testversion 2.0.49
	dh_testdir
	dh_testroot
	# Don't modify postrm, I purge differently than normal packages
	# using me.
	dh_installdebconf -n
	dh_installdocs doc/CREDITS doc/*.txt doc/*.html \
		doc/spec/*.txt doc/spec/*.html \
		README TODO
	dh_installexamples samples/*
	dh_installmenu
	dh_installcron
	dh_installmanpages -p debconf
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_suidregister
	dh_installdeb
	# Hack to make sure debconf-tiny has the same version.
	mv debian/debconf-tiny.changelog debian/debconf-tiny.changelog.bak
	dh_gencontrol
	mv debian/debconf-tiny.changelog.bak debian/debconf-tiny.changelog
	dh_md5sums -p debconf
	dh_builddeb

# Build architecture-dependent files here.
binary-arch: build install
# Nothing to do.

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## debconf 0.9.74

=== Makefile ===
pod2man=pod2man -c Debconf -r ""

all:
	$(MAKE) -C doc
	$(MAKE) -C po

clean:
	find . -name \*~ | xargs rm -f
	$(MAKE) -C doc clean
	$(MAKE) -C po clean
	rm -f *.db

install: install-utils install-docs install-rest

# Man pages that go in the debconf-doc package.
install-man:
	install -d $(prefix)/usr/share/man/man3
	install -d $(prefix)/usr/share/man/man8
	install -d $(prefix)/usr/share/man/man5
	$(pod2man) --section=3 Debconf/Client/ConfModule.pm \
		> $(prefix)/usr/share/man/man3/Debconf::Client::ConfModule.3pm
	install -m 0644 confmodule.3 $(prefix)/usr/share/man/man3/
	install -m 0644 debconf.8 $(prefix)/usr/share/man/man8/
	install -m 0644 debconf.conf.5 $(prefix)/usr/share/man/man5/

# Anything that goes in the debconf-utils package.
install-utils:
	install -d $(prefix)/usr/bin
	find . -maxdepth 1 -perm +100 -type f -name 'debconf-*' | grep -v debconf-show | \
		xargs -i install {} $(prefix)/usr/bin
	# Make man pages for utils.
	install -d $(prefix)/usr/share/man/man1
	find . -maxdepth 1 -perm +100 -type f -name 'debconf-*' -printf '%P\n' | grep -v debconf-show | \
		xargs -i sh -c '$(pod2man) --section=1 {} > $(prefix)/usr/share/man/man1/`basename {}`.1'

# Install all else.
install-rest:
	$(MAKE) -C po install
	install -d $(prefix)/etc \
		$(prefix)/var/cache/debconf \
		$(prefix)/usr/share/debconf
	install -m 0644 debconf.conf $(prefix)/etc/
	# This one is the ultimate backup copy.
	grep -v '^#' debconf.conf > $(prefix)/usr/share/debconf/debconf.conf
	# Make module directories.
	find Debconf -type d |grep -v CVS | \
		xargs -i install -d $(prefix)/usr/share/perl5/{}
	# Install modules.
	find Debconf -type f -name '*.pm' |grep -v CVS | \
		xargs -i install -m 0644 {} $(prefix)/usr/share/perl5/{}
	# Special case for back-compatability.
	install -d $(prefix)/usr/share/perl5/Debian/DebConf/Client
	cp Debconf/Client/ConfModule.stub \
		$(prefix)/usr/share/perl5/Debian/DebConf/Client/ConfModule.pm
	# Other libs and helper stuff.
	install -m 0644 confmodule.sh confmodule $(prefix)/usr/share/debconf/
	install frontend $(prefix)/usr/share/debconf/
	install -m 0755 transition_db.pl $(prefix)/usr/share/debconf/
	# Install essential programs.
	install -d $(prefix)/usr/sbin
	find . -maxdepth 1 -perm +100 -type f -name 'dpkg-*' -or -name debconf-show | \
		xargs -i install {} $(prefix)/usr/sbin
	# Make man pages for programs.
	install -d $(prefix)/usr/share/man/man8
	find . -maxdepth 1 -perm +100 -type f \( -name 'dpkg-*' -or -name debconf-show \) -printf '%P\n' | \
		xargs -i sh -c '$(pod2man) --section=8 {} > $(prefix)/usr/share/man/man8/`basename {}`.8'
	# Now strip all pod documentation from all .pm files and scripts.
	find $(prefix)/usr/share/perl5/ $(prefix)/usr/sbin		\
	     $(prefix)/usr/share/debconf/frontend 			\
	     $(prefix)/usr/share/debconf/*.pl				\
	     -name '*.pm' -or -name 'dpkg-*' | 				\
	     grep -v Client/ConfModule | xargs perl -i.bak -ne ' 	\
	     		print $$_."# This file was preprocessed, do not edit directly.\n" \
				if m:^#!/usr/bin/perl:; 		\
	     		$$cutting=1 if /^=/; 				\
	     		$$cutting="" if /^=cut/; 			\
			next if /use lib/;				\
			next if $$cutting || /^(=|\s*#)/ || $$_ eq "\n";\
			print $$_					\
		'
	find $(prefix) -name '*.bak' | xargs rm -f

demo:
	PERL5LIB=. ./frontend samples/demo

=== doc/Makefile ===
FILES=$(patsubst %.xml,%.txt,$(wildcard *.xml)) \
      $(patsubst %.xml,%.html,$(wildcard *.xml))

all: $(FILES)
	./graph.pl `find .. -name \*.pm` > hierarchy.txt

%.html: %.xml html.dsl
	jade -V nochunks -t sgml -d html.dsl \
		/usr/lib/sgml/declaration/xml.dcl $< > $@
	-tidy -i -m -f /dev/null $@

%.txt: %.html
	perl -pe 's/[\r\0]//g' $< | html2text -style pretty -nobs > $@

clean:
	rm -f $(FILES) hierarchy.txt *.css *.html

=== po/Makefile ===
# List here all source files with translatable strings.
POTFILES=$(shell find ../Debconf -type f -name \*.pm) \
	../dpkg-* ../debconf-*

POFILES=$(wildcard *.po)
MOFILES=$(POFILES:.po=.mo)

all: debconf.pot $(MOFILES)

install: all
	for file in $(MOFILES); do \
		lang=`echo $$file | sed 's/\.mo//'`; \
		install -d $(prefix)/usr/share/locale/$$lang/LC_MESSAGES/; \
		install -m 0644 $$file $(prefix)/usr/share/locale/$$lang/LC_MESSAGES/debconf.mo; \
	done

debconf.pot: $(POTFILES)
# xgettext can mostly handle perl files as C files, though it gets a bit
# confused about single quotes in comments, and the gettext() calls have to
# use double-quoted strings or it will ignore them.
	@echo "Rebuilding the pot file"
	xgettext $(POTFILES) -o debconf.pot -Lc

clean:
	rm -f debconf.pot $(MOFILES) messages

%.mo: %.po
	msgfmt -o $@ $<

%.po: debconf.pot
	@echo -n "Merging debconf.pot and $@"
	@msgmerge $@ debconf.pot -o $@.new
# Typically all that changes was a date. I'd prefer not to cvs commit such
# changes, so detect and ignore them.
	@if [ "`diff $@ $@.new | grep '[<>]' | wc -l`" -ne 2 ]; then \
		mv -f $@.new $@; \
	else \
		rm -f $@.new; \
	fi
	@msgfmt --statistics $@

=== debian/changelog ===
debconf (0.9.74) unstable; urgency=low

  * Introducing terse mode. You know what you're doing, and so you're using
    the text frontend (of course!) as you do a remote upgrade from rexx over
    a 30 hop, 95% packet loss link to another continent. Every byte hurts. 
    You don't need all those touchy-feely verbose help screens. Terse mode is
    for you. (Well, for me anyway. Damn this wireless link.)
       # dpkg-reconfigure debconf --terse
       What interface should be used for configuring packages? Text
       Ignore questions with a priority less than.. low
       Show all old questions again and again? no
  * Added DEBCONF_TERSE variable.
  * Added terse support to text frontend.
  * Renamed debconf/helpvisible to debconf/terse.
  * Terse can be configured in debconfrc and with --terse too.
  * Finally tracked down the mysterious text frontend title printing bug --
    it happened if nothing was displayed, but a note was mailed.
  * Updated korean translation from Eungkyu Song <eungkyu@sparcs.org>
    Closes: #103260
  * Added brazillian portuguese po file from Gustavo Noronha Silva
    <kov@debian.org>, Closes: #103253

 -- Joey Hess <joeyh@debian.org>  Tue,  3 Jul 2001 00:22:15 -0400

debconf (0.9.73) unstable; urgency=low

  * Added debconf-show, which displays all questinos belonging to a
    package, their values, and indicates if they have been seen or not, all
    in a compact format handy for bug reports. Now why didn't I think of
    this before?
  * To keep the bit scales balanced, removed an unused template.

 -- Joey Hess <joeyh@debian.org>  Mon, 25 Jun 2001 15:22:15 -0400

debconf (0.9.72) unstable; urgency=low

  * Dropped libterm-stool-perl down to a suggests.

 -- Joey Hess <joeyh@debian.org>  Sun, 24 Jun 2001 21:29:48 -0400

debconf (0.9.71) unstable; urgency=HIGH

  * No changes. Testing has debconf 0.9.41, which breaks under perl 5.6.1.
    5.6.1 just went into testing. This needs to go in ASAP.
  * aj, if you see this, this is your cue to slam this package into testing
    without any delay at all.

 -- Joey Hess <joeyh@debian.org>  Thu, 21 Jun 2001 20:16:26 -0400

debconf (0.9.70) unstable; urgency=low

  * Fixed pod2man silly man page header issue. Closes: #101766

 -- Joey Hess <joeyh@debian.org>  Thu, 21 Jun 2001 13:11:16 -0400

debconf (0.9.69) unstable; urgency=low

  * Fix doc link, Closes: #101114 

 -- Joey Hess <joeyh@debian.org>  Sat, 16 Jun 2001 12:37:32 -0400

debconf (0.9.68) unstable; urgency=low

  * Fixed the last known bug in the text frontend, cleaned up TODO.

 -- Joey Hess <joeyh@debian.org>  Fri, 15 Jun 2001 20:00:15 -0400

debconf (0.9.67) unstable; urgency=low

  * Let's make the templates cache mode 644. There's nothing sentative in
    there. (Modified the debconf.conf file.)
  * Convert Mode field to octal on the fly to precent confusion.
  * Spell checked debconf.conf.5. Along the way, I discovered that a field
    name in the debconf db was mispelled. So, "Extention" should really be
    "Extension". Update your debconf.conf. Since this is not used in the
    stock config file, and I've never seen it used, I did just rename the
    field, breaking backwards compatability.

 -- Joey Hess <joeyh@debian.org>  Thu, 14 Jun 2001 20:27:52 -0400

debconf (0.9.66) unstable; urgency=low

  * Prevent Editor::Note's from feeding undef values into the db, 
    Closes: #100776

 -- Joey Hess <joeyh@debian.org>  Thu, 14 Jun 2001 12:37:14 -0400

debconf (0.9.65) unstable; urgency=low

  * Fixed unsupported command message to include the syntax error code.
  * Also, include full line in the error message, may make debugging easier.

 -- Joey Hess <joeyh@debian.org>  Wed, 13 Jun 2001 17:41:13 -0400

debconf (0.9.64) unstable; urgency=low

  * Updated the user's guide frontend section.

 -- Joey Hess <joeyh@debian.org>  Mon, 11 Jun 2001 00:04:57 -0400

debconf (0.9.63) unstable; urgency=low

  * Man page section fixes, Closes: #100076
  * Noted in description of shell library that yes, the protocol commands
    are lower-cased (it already explained about the db_ prefixing). 
    Closes: #100276
  * Text frontend UI changes: select and multiselect lists no longer have
    lettered choices. Instead, it uses numbers, and any unique anchored
    substring of a choice is understood, too. The old system was great,
    except when it sucked. This should scale more evenly.
  * Added full completion to the text frontend! Now it really is the best
    frontend, for sure..
  * French po file update from Martin Quinson <Martin.Quinson@ens-lyon.fr>.
  * Fixed an obscure bug that made the REGISTER command fail if the owner
    was set to "" (or any other perlwise-false string).

 -- Joey Hess <joeyh@debian.org>  Wed,  6 Jun 2001 11:53:43 -0400

debconf (0.9.62) unstable; urgency=low

  * Updated Korean translation (templates, not po file) from Eungkyu Song
    <eungkyu@sparcs.kaist.ac.kr>, Closes: #99034

 -- Joey Hess <joeyh@debian.org>  Mon, 28 May 2001 13:35:28 -0400

debconf (0.9.61) unstable; urgency=low

  * Added some space after prompts in text frontend, which seems to
    visually set off each new question more clearly.
  * Made the text frontend's long-broken shutdown() method work, to
    always ensure you have hit enter at a prompt if a message is printed
    out as the last part of a debconf run. After trying that out for a bit,
    I found I hated it, so I removed the method.
  * Put a blank line between short description and long description for
    notes.
  * In template parsing, don't add leading spaces before new paragraphs.
    (This was manifesting as an ugly one-space indent on paragraphs 2 and
    on, in the text frontend.)

 -- Joey Hess <joeyh@debian.org>  Sun, 27 May 2001 20:03:47 -0400

debconf (0.9.60) unstable; urgency=low

  * Make dpkg-preconfigure read all of its input in --apt mode, even if it
    cannot preconfigure, so apt doesn't think it failed. However, this will


=== debian/control ===
Source: debconf
Section: admin
Priority: optional
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.5.5.0
Build-Depends: perl, debhelper (>= 3.0.5), gettext, html2text, jade, sp, docbook-xml, docbook-stylesheets, sgml-data (>= 1.2), tidy

Package: debconf
Priority: important
Pre-Depends: perl-base (>= 5.6.1-4)
Conflicts: debconf-utils (<< 0.9), debconf-tiny, apt (<< 0.3.12.1), menu (<= 2.1.3-1), dialog (<< 0.9a-20000730-1), whiptail (<< 0.50.8-1), libterm-stool-perl (<< 0.20), cdebconf (<< 0.10-5)
Provides: debconf-tiny
Replaces: debconf-tiny
Depends: fileutils (>= 4.0-5)
Recommends: apt-utils (>= 0.5.1)
Suggests: debconf-doc, debconf-utils, whiptail | dialog | gnome-utils, liblocale-gettext-perl, libterm-stool-perl | libterm-readline-gnu-perl
Architecture: all
Description: Debian configuration management system
 Debconf is a configuration management system for debian packages. Packages
 use Debconf to ask questions when they are installed.

Package: debconf-doc
Conflicts: debconf (<< 0.3.10)
Suggests: debian-policy (>= 3.5)
Section: doc
Architecture: all
Description: Debian configuration management system documentation
 This package contains lots of additional documentation for Debconf,
 including an introduction to Debconf, a user's guide, a programmer's
 tutorial, and the specification Debconf is based on.

Package: debconf-utils
Section: devel
Depends: debconf (>= 0.9.59)
Conflicts: debconf (<< 0.3.31)
Replaces: debconf (<< 0.3.31)
Architecture: all
Description: Debconf utilities
 This package contains some small utilities to aid users and developers.
 There are utilities to help manage debconf databases, other to manage
 translated template files and a program to communicate directly with
 debconf from the command line.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatibility version to use.
export DH_COMPAT=3

# Ensure that builds are self-hosting, which means I have to use the .pm
# files in this package, not any that may be on the system.
export PERL5LIB=.

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE) -C po
	$(MAKE) -C doc
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) clean
	dh_clean debian/debconf.changelog
	# Just so non-debian folks will know where to find it.
	ln -sf ../debian/copyright doc/COPYRIGHT

# Build architecture-independent files here.
binary-indep:
binary-indep: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs etc/apt/apt.conf.d

	$(MAKE) prefix=`pwd`/debian/debconf-doc install-man
	$(MAKE) prefix=`pwd`/debian/debconf-utils install-utils
	$(MAKE) prefix=`pwd`/debian/debconf install-rest

	install -m 0644 debian/apt.conf \
		debian/debconf/etc/apt/apt.conf.d/70debconf

	# Don't modify postrm, I purge differently than normal packages
	# using me
	PATH=.:$(PATH) dh_installdebconf -n
	
	dh_installdocs 
	dh_installexamples -pdebconf-doc samples/*
	
	# Changelog reduction hack for debconf. Only include top 5 entries.
	perl -ne '$$c++ if /^debconf /; last if $$c > 5 ; print $$_' \
		< debian/changelog > debian/debconf.changelog
	echo "See /usr/share/doc/debconf-doc/changelog.gz for the" >> debian/debconf.changelog
	echo "remainder of this changelog." >> debian/debconf.changelog

	dh_installchangelogs
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-arch:
# Nothing to do

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## debconf 1.0.32

=== Makefile ===
all:
	$(MAKE) -C doc
	$(MAKE) -C po

clean:
	find . -name \*~ | xargs rm -f
	$(MAKE) -C doc clean
	$(MAKE) -C po clean

# Does not attempt to install documentation, as that can be fairly system
# specific.
install: install-utils install-rest

# Anything that goes in the debconf-utils package.
install-utils:
	install -d $(prefix)/usr/bin
	find . -maxdepth 1 -perm +100 -type f -name 'debconf-*' | grep -v debconf-show | \
		xargs -i install {} $(prefix)/usr/bin

# Install all else.
install-rest:
	$(MAKE) -C po install
	install -d $(prefix)/etc \
		$(prefix)/var/cache/debconf \
		$(prefix)/usr/share/debconf \
		$(prefix)/usr/share/pixmaps
	install -m 0644 debconf.conf $(prefix)/etc/
	install -m 0644 debian-logo.xpm $(prefix)/usr/share/pixmaps/
	# This one is the ultimate backup copy.
	grep -v '^#' debconf.conf > $(prefix)/usr/share/debconf/debconf.conf
	# Make module directories.
	find Debconf -type d |grep -v CVS | \
		xargs -i install -d $(prefix)/usr/share/perl5/{}
	# Install modules.
	find Debconf -type f -name '*.pm' |grep -v CVS | \
		xargs -i install -m 0644 {} $(prefix)/usr/share/perl5/{}
	# Special case for back-compatability.
	install -d $(prefix)/usr/share/perl5/Debian/DebConf/Client
	cp Debconf/Client/ConfModule.stub \
		$(prefix)/usr/share/perl5/Debian/DebConf/Client/ConfModule.pm
	# Other libs and helper stuff.
	install -m 0644 confmodule.sh confmodule $(prefix)/usr/share/debconf/
	install frontend $(prefix)/usr/share/debconf/
	install -m 0755 transition_db.pl fix_db.pl $(prefix)/usr/share/debconf/
	# Install essential programs.
	install -d $(prefix)/usr/sbin
	find . -maxdepth 1 -perm +100 -type f -name 'dpkg-*' -or -name debconf-show | \
		xargs -i install {} $(prefix)/usr/sbin
	# Now strip all pod documentation from all .pm files and scripts.
	find $(prefix)/usr/share/perl5/ $(prefix)/usr/sbin		\
	     $(prefix)/usr/share/debconf/frontend 			\
	     $(prefix)/usr/share/debconf/*.pl				\
	     -name '*.pm' -or -name 'dpkg-*' | 				\
	     grep -v Client/ConfModule | xargs perl -i.bak -ne ' 	\
	     		print $$_."# This file was preprocessed, do not edit!\n" \
				if m:^#!/usr/bin/perl:; 		\
	     		$$cutting=1 if /^=/; 				\
	     		$$cutting="" if /^=cut/; 			\
			next if /use lib/;				\
			next if $$cutting || /^(=|\s*#)/ || $$_ eq "\n";\
			print $$_					\
		'
	find $(prefix) -name '*.bak' | xargs rm -f

demo:
	PERL5LIB=. ./frontend samples/demo

=== doc/Makefile ===
--- 
+++ 
@@ -1,8 +1,22 @@
 FILES=$(patsubst %.xml,%.txt,$(wildcard *.xml)) \
       $(patsubst %.xml,%.html,$(wildcard *.xml))
 
-all: $(FILES)
+all: $(FILES) manpages
 	./graph.pl `find .. -name \*.pm` > hierarchy.txt
+
+pod2man=pod2man -c Debconf -r ''
+manpages:
+	install -d man/gen
+	for num in 1 3 8; do \
+		find man -maxdepth 1 -type f -name "*.$$num.pod" -printf '%P\n' | \
+			xargs -i sh -c "cd man ; $(pod2man) --section=$$num {} > gen/\`basename {} .pod\`"; \
+	done
+	$(pod2man) --section=3 ../Debconf/Client/ConfModule.pm \
+		> man/gen/Debconf::Client::ConfModule.3pm
+	find .. -maxdepth 1 -perm +100 -type f -name 'debconf-*' -printf '%P\n' | \
+		xargs -i sh -c "cd .. ; $(pod2man) --section=1 {} > doc/man/gen/{}.1"
+	find .. -maxdepth 1 -perm +100 -type f -name 'dpkg-*' -printf '%P\n' | \
+		xargs -i sh -c "cd .. ; $(pod2man) --section=8 {} > doc/man/gen/{}.8"
 
 %.html: %.xml html.dsl
 	jade -V nochunks -t sgml -d html.dsl \
@@ -14,3 +28,4 @@
 
 clean:
 	rm -f $(FILES) hierarchy.txt *.css *.html
+	rm -rf man/gen

=== po/Makefile ===
--- 
+++ 
@@ -38,3 +38,10 @@
 		rm -f $@.new; \
 	fi
 	@msgfmt --statistics $@
+
+check:
+	@for file in $(POFILES); do \
+		lang=`echo $$file | sed 's/\.po//'`; \
+		printf "$$lang: "; \
+		msgfmt -o /dev/null -c -v --statistics $$lang.po;\
+	done

=== debian/changelog ===
debconf (1.0.32) unstable; urgency=low

  * Fixed a bug in the Stack driver's iterator, needed by FAI.
    Thanks to Joerg Lehmann <joerg@luga.de> for the patch.
  * Typo and spelling corrections (did not change verbiage to verbage however;
    I do not intend that connotation). Closes: #131807
  * Added --force to dpkg-reconfigure.
  * Fixed typo in debconf.conf. Closes: #140085

 -- Joey Hess <joeyh@debian.org>  Thu,  7 Mar 2002 21:27:18 -0500

debconf (1.0.31) unstable; urgency=low

  * Versioned conflicts with debconf-tiny, see #137019
  * Corrected some wording in the German translation. Closes: #137005
  * Removed translated default fields in the Russian template (don't do that,
    folks).

 -- Joey Hess <joeyh@debian.org>  Tue,  5 Mar 2002 19:54:40 -0500

debconf (1.0.30) unstable; urgency=low

  * Matthew Palmer <mjp16@ieee.uow.edu.au> contributed a LDAP backend
    database for debconf. This will open up all kinds of new possiilities
    for using debconf in a cluster, etc. It is currently experimental, and
    will not be used unless you enable it; so there is no chance this new
    code will impact the freeze.
  * Wrote debconf-devel(8) man page, which attempts to be a complete
    reference for developing packages that use debconf. Read it.
  * Fixed the doc-base name of the debconf tutorial.
  * Minor change to debconf-mergetemplate man page synopsis.
  * Refuse to use the dialog frontend if the screen is too small,
    it'll fall back to the text frontend which will work on screens
    down to about 2 lines of 20 characters each. Closes: #132972
  * Fixed typo, Closes: #134161
  * Patch from Denis Barbier <barbier@debian.org> to make debconf-getlang
    work better with ll_LL form languages. Closes: #134307
  * Display choices for boolean questions in the editor frontend, 
    Closes: #135078
  * Improved the section in the tutorial on translations. Patch from Denis
    Barbier. Closes: #96836
  * Added a new Russian template from Ilgiz Kalmetev, Closes: #135839

 -- Joey Hess <joeyh@debian.org>  Tue,  5 Feb 2002 20:37:19 -0500

debconf (1.0.26) unstable; urgency=low

  * Removed uninitialized value warning in Teletype frontend.
    Actually, this was a bug that did not let it display only one column on
    choices when necessary; triggered by quake2-data.
  * Incuded a short README.Debian for debconf-utils, Closes: #129541
  * Made the README point to all the main docs for users and developers.
    Closes: #129545
  * Deregister SIGPIPE handler after confmodule finishes, so it is not called
    after the object is gone. Closes: #129463
  * Chomp whitespace at the end of field continuation lines; this fixes a
    bug that caused some indented lines to be accidentially wrapped up to
    the previous line.
  * Stop using funky grave quotes in this package's templates.
  * Updated Spanish template. Closes: #128838
  * Updated Catalan.
  * Added German po file, updated templates.
  * Killed the following overly-outdated translated templates: pl, ru,
    zh_CN, zh_TW, nl, ja, it.
  * fi and gl have one fuzzy translation each, and all the rest are fine.
  * Corrected incorrect indents in a number of translated templates, sigh.
  * debconf(8) tweak, Closes: #130348

 -- Joey Hess <joeyh@debian.org>  Fri, 11 Jan 2002 23:30:25 -0500

debconf (1.0.25) unstable; urgency=medium

  * The "bite the bullet" release.
  * Enhanced fix_db.pl to detect and deal with every debconf db corruption
    scenario that has been reported to me. Run it on upgrade from versions
    prior to this one. I suspect that all instances of inconsistent and
    corrupt debconf db's are due to past bugs in debconf and especially the
    transition from the crufty old data::dumper db, and the "fix" for the
    missing template problem, plus possibly some unclean shutdown problems.
    So fix them all now, and either the problems go away for good or I prove
    my theories wrong if they pop back up later. 
  * Closes: #128707, #128265, #99786

 -- Joey Hess <joeyh@debian.org>  Fri, 11 Jan 2002 13:25:06 -0500

debconf (1.0.24) unstable; urgency=low

  * Reverted the $Text::Wrap::break change from the last version, as that was
    making Text::Wrap eliminate multiple \n's, which leads to display
    problems. Closes: #128034

 -- Joey Hess <joeyh@debian.org>  Sun,  6 Jan 2002 14:59:58 -0500

debconf (1.0.23) unstable; urgency=low

  * Delete vanishing extended descriptions when merging templates.
    Closes: #126239
  * Set $Text::Wrap::break=q/\s+/ everywhere I use Text::Wrap,
    see bug #126202
  * zh_TW.Big5.po update

 -- Joey Hess <joeyh@debian.org>  Mon, 17 Dec 2001 17:13:39 -0500

debconf (1.0.22) unstable; urgency=HIGH

  * I've had a number of reports of truncated templates files (that make
    debconf crash later). Some if not all are related to system hangs while
    an upgrade is in progress. Since debconf is already very careful to do
    updates atomically, nearly the only safety feature left is to sync files
    after writing them, which I have now done for all db file writes. My 
    hypothesis is that the atomicity was being thwarted by disk caching.
    Closes: #122891, #112921, #122825, #112921 (??)
  * Directory DbDriver was unlocking the db too early, fixed.
  * ConfModule: on startup(), automatically CLEAR. Closes: #122176
  * Fixed crash if a question is INPUT, UNREGISTERed, and then we GO.
    Closes: #120303
  * Updated fr.po from Martin Quinson <Martin.Quinson@ens-lyon.fr>
  * Also a patch from Martin to make 'make check' in po output stats.

 -- Joey Hess <joeyh@debian.org>  Fri,  7 Dec 2001 11:10:12 -0500

debconf (1.0.21) unstable; urgency=high

  * High urgency upload to get this into testing before the freeze, as it
    fixes a bug that can cripple upgrades from stable.
  * Conflict with whiptail << 0.50.17-7, as some version between that one and
    the 0.50-7 in stable changes something that is required to make the 


=== debian/control ===
Source: debconf
Section: admin
Priority: optional
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.5.6.1
Build-Depends-Indep: perl, debhelper (>= 3.0.5), gettext, html2text (>= 1.2.4-7), jade, sp, docbook-xml, docbook-dsssl, sgml-data (>= 1.2), tidy

Package: debconf
Priority: important
Pre-Depends: perl-base (>= 5.6.1-4)
Conflicts: debconf-utils (<< 0.9), debconf-tiny (<< 1.0), apt (<< 0.3.12.1), menu (<= 2.1.3-1), dialog (<< 0.9a-20000730-1), whiptail (<< 0.50.17-7), cdebconf (<< 0.10-5)
Provides: debconf-tiny
Replaces: debconf-tiny
Depends: fileutils (>= 4.0-5)
Recommends: apt-utils (>= 0.5.1)
Suggests: debconf-doc, debconf-utils, whiptail | dialog | gnome-utils, liblocale-gettext-perl, libterm-readline-gnu-perl, libgnome-perl, libnet-ldap-perl
Architecture: all
Description: Debian configuration management system
 Debconf is a configuration management system for debian packages. Packages
 use Debconf to ask questions when they are installed.

Package: debconf-doc
Conflicts: debconf (<< 0.3.10)
Suggests: debian-policy (>= 3.5)
Section: doc
Architecture: all
Description: Debian configuration management system documentation
 This package contains lots of additional documentation for Debconf,
 including an introduction to Debconf, a user's guide, a programmer's
 tutorial, and the specification Debconf is based on.

Package: debconf-utils
Section: devel
Depends: debconf (>= 0.9.59)
Conflicts: debconf (<< 0.3.31)
Replaces: debconf (<< 0.3.31)
Architecture: all
Description: debconf utilities
 This package contains some small utilities to aid users and developers.
 There are utilities to help manage debconf databases, others to manage
 translated template files and a program to communicate directly with
 debconf from the command line.

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,7 @@
 build: build-stamp
 build-stamp:
 	dh_testdir
-	$(MAKE) -C po
-	$(MAKE) -C doc
+	$(MAKE)
 	touch build-stamp
 
 clean:
@@ -34,7 +33,6 @@
 	dh_clean -k
 	dh_installdirs etc/apt/apt.conf.d
 
-	$(MAKE) prefix=`pwd`/debian/debconf-doc install-man
 	$(MAKE) prefix=`pwd`/debian/debconf-utils install-utils
 	$(MAKE) prefix=`pwd`/debian/debconf install-rest
 
@@ -46,6 +44,10 @@
 	PATH=.:$(PATH) dh_installdebconf -n
 	
 	dh_installdocs 
+	dh_installman doc/man/gen/dpkg-*.8 doc/man/gen/debconf-show*.1
+	dh_installman -p debconf-doc doc/man/confmodule*.3 doc/man/debconf*.8 \
+		doc/man/debconf.conf*.5 doc/man/gen/Debconf::Client::ConfModule*
+	dh_installman -p debconf-utils `find doc/man/gen/debconf-* | grep -v debconf-show`
 	dh_installexamples -pdebconf-doc samples/*
 	
 	# Changelog reduction hack for debconf. Only include top 5 entries.
